package io.modules.sys.controller;


import io.common.annotation.LogOperation;
import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.CategoriesDTO;
import io.modules.item.dto.HouseDTO;
import io.modules.item.entity.ViewEntity;
import io.modules.item.service.CategoriesService;
import io.modules.item.service.HouseService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 主表
 */
@CrossOrigin
@RestController
@RequestMapping("sys/house")
@Tag(name = "主表")
public class HouseController {
    @Autowired
    private HouseService itemService;


    @GetMapping("query")
    @Operation(summary = "首页顶部展示")
    public Result<List<Object>> page() {
        List<Object> res = itemService.query();
        return new Result<List<Object>>().ok(res);
    }

    @GetMapping("view1")
    @Operation(summary = "首页分析1")
    public Result<List<ViewEntity>> view1() {
        List<ViewEntity> res = itemService.view1();
        return new Result<List<ViewEntity>>().ok(res);
    }

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
            @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref = "int"),
            @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY, required = true, ref = "int"),
            @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref = "String"),
            @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref = "String"),
            @Parameter(name = "status", description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref = "String")
    })
    public Result<PageData<HouseDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params) {

        PageData<HouseDTO> page = itemService.page(params);
        List<HouseDTO> list = page.getList().stream().map(e -> {

            return e;
        }).collect(Collectors.toList());
        page.setList(list);
        return new Result<PageData<HouseDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")
    public Result<HouseDTO> get(@PathVariable("id") Long id) {
        HouseDTO data = itemService.get(id);
        return new Result<HouseDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")
    public Result save(@RequestBody HouseDTO dto) {
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        itemService.save(dto);
        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")
    public Result update(@RequestBody HouseDTO dto) {        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        itemService.update(dto);
        return new Result();
    }

    @DeleteMapping("{id}")
    @Operation(summary = "删除")
    @LogOperation("删除")
    public Result delete(@PathVariable Long id) {
        Long[] ids = new Long[]{id};
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        itemService.delete(ids);
        return new Result();
    }


}
